#ifdef GL_ES
precision highp float;
#endif
uniform sampler2D uSrc;
uniform vec2 uDelta;
uniform vec4 uBlurDir;
uniform sampler2D uClear;

varying vec2 textureCoord;

void main(void) {
    vec4 clear = texture2D(uClear, textureCoord);
    vec4 col = texture2D(uSrc, textureCoord);
    vec4 dir = uBlurDir * (vec4(1.0, 1.0, 1.0, 1.0) - clear);

    col = col + texture2D(uSrc, textureCoord + dir.xy * uDelta);
    col = col + texture2D(uSrc, textureCoord - dir.xy * uDelta);
    col = col + texture2D(uSrc, textureCoord + (dir.xy + dir.zw) * uDelta);
    col = col + texture2D(uSrc, textureCoord - (dir.xy + dir.zw) * uDelta);

    gl_FragColor = col / 5.0;
}