precision highp float;
precision highp sampler2D;

varying vec2 textureCoord;
uniform sampler2D uTarget;
uniform float aspectRatio;
uniform vec4 color;
uniform vec2 point;
uniform float radius;
uniform int actionDown;

void main () {
    vec2 p = textureCoord - point.xy;
    p.x *= aspectRatio;
    vec4 splat = exp(-dot(p, p) / radius) * color;
    vec4 base = texture2D(uTarget, textureCoord);

    vec4 col = vec4(base + splat);
    col.x = min(1.0, col.x);
    col.y = min(1.0, col.y);
    col.z = min(1.0, col.z);
    col.w = min(1.0, col.w);

    float restore = 0.0001;
    if (actionDown == 1) {
        restore = 0.0;
    } else {
        if (col.x < 0.98) {
            restore = 0.01;
        } else if (col.x < 0.2) {
            restore = 1.0;
        }
    }

    col = col - vec4(restore, restore, restore, restore);
    col.x = max(0.0, col.x);
    col.y = max(0.0, col.y);
    col.z = max(0.0, col.z);
    col.w = max(0.0, col.w);

    gl_FragColor = col;
}