precision highp float;
precision highp sampler2D;

uniform sampler2D texture0;
uniform float amount;
uniform float time;
uniform float aspect;
//uniform vec3 drops[32];// x,y are pos z is age
uniform vec3 drops0;
uniform vec3 drops1;
uniform vec3 drops2;
uniform vec3 drops3;
uniform vec3 drops4;

varying vec2 texCoordV;

vec2 doDrops(vec3 drop, vec2 surf, vec2 txC) {
    float dist;
    float wave;
    vec2 dir;
    float w;

    if (drop.z > -90.0){
        dir = drop.xy - txC;
        dist = length(dir);
        dir = normalize(dir);
        w = cos((4.0 / (1.0 + pow(2.0, dist * 50.0 - drop.z))) * 3.1415926 * 2.0) * -0.5 + 0.5;
        wave = w * pow(2.0, -dist * 8.0);
        surf += dir * wave;
    }

    return surf;
}

void main() {
    vec2 offset;
    float dist;
    float wave;
    vec2 surf;
    vec2 dir;
    vec2 txC;
    float w;
    float cau;

    txC = texCoordV * vec2(1.0, aspect);
    cau = distance(vec2(-1.0, -1.0), txC) * 20.0 + time;
    surf = vec2(sin(cau), cos(cau)) * 0.01;
    cau = distance(vec2(1.0, 1.0), txC) * 30.0 + time;
    surf += vec2(sin(cau), cos(cau)) * 0.02;

//    for (int i = 0; i < 32; i += 1){
//        if (drops[i].z > -90.0){
//            dir = drops[i].xy - txC;
//            dist = length(dir);
//            dir = normalize(dir);
//            w = cos((4.0 / (1.0 + pow(2.0, dist * 50.0 - drops[i].z))) * 3.1415926 * 2.0) * -0.5 + 0.5;
//            wave = w * pow(2.0, -dist * 8.0);
//            surf += dir * wave;
//        }
//    }

    surf = doDrops(drops0, surf, txC);
//    surf = doDrops(drops1, surf, txC);
//    surf = doDrops(drops2, surf, txC);
//    surf = doDrops(drops3, surf, txC);
//    surf = doDrops(drops4, surf, txC);

    offset = texCoordV + surf * amount;
    vec3 tx = vec3(texCoordV, 0.0);
    vec3 norm = normalize(vec3(surf, 1.0));
    vec3 toLight = normalize(vec3(0.0, -0.0, 1.0) - tx);
    vec3 toCamera = normalize(vec3(0.0, 0.0, 1.0) - tx);
    vec3 lRef = normalize(2.0 * dot(norm, toLight) * norm - toLight);
    float spec = dot(lRef, toCamera) * 2.0;
    spec = clamp(spec, 0.0, 1.3) - 0.6;
    spec = pow(spec, 8.0) * 4.0;
    vec4 col = texture2D(texture0, offset);
    if (spec >= 0.0) {
        col.xyz = col.xyz + spec;
    }
    gl_FragColor = col;

//    gl_FragColor = texture2D(texture0, texCoordV);
//    gl_FragColor.r *= cos(surf.x + surf.y + cau + amount + time + aspect);

//    gl_FragColor = texture2D(texture0, texCoordV);
//    gl_FragColor.r *= cos(surf + amount);
}